
#ifndef _KHAN_H
#define _KHAN_H

#define	    OUTA *AT91C_PIOA_PER=*AT91C_PIOA_OER // Port Enable Resistor for port x(a,b or c  , d )
#define	   	OUTB *AT91C_PIOB_PER=*AT91C_PIOB_OER
#define	   	OUTC *AT91C_PIOC_PER=*AT91C_PIOC_OER
#define	   	OUTD *AT91C_PIOD_PER=*AT91C_PIOD_OER

#define	    INIA  *AT91C_PIOA_PER=*AT91C_PIOA_ODR   //Input Enable(Output Disable Register) Resistor for port x(a,b or c  , d ) 
#define	   	INIB  *AT91C_PIOB_PER=*AT91C_PIOB_ODR
#define	   	INIC  *AT91C_PIOC_PER=*AT91C_PIOB_ODR
#define	   	INID  *AT91C_PIOD_PER=*AT91C_PIOD_ODR

#define	    PERA  *AT91C_PIOA_PER  // Port Enable Resistor for port x(a,b or c  , d )
#define	   	PERB  *AT91C_PIOB_PER
#define	   	PERC  *AT91C_PIOC_PER
#define	   	PERD  *AT91C_PIOD_PER

#define	    OERA  *AT91C_PIOA_OER //Output Enable Resistor for port x(a,b or c  , d ) 
#define	   	OERB  *AT91C_PIOB_OER
#define	   	OERC  *AT91C_PIOC_OER
#define	   	OERD  *AT91C_PIOD_OER

#define	    IERA  *AT91C_PIOA_ODR //Input Enable(Output Disable Register) Resistor for port x(a,b or c  , d ) 
#define	   	IERB  *AT91C_PIOB_ODR
#define	   	IERC  *AT91C_PIOC_ODR
#define	   	IERD  *AT91C_PIOD_ODR

#define	    DDRA  *AT91C_PIOA_OWER  // direct driver Enable Resistor for port x(a,b or c  , d )
#define	   	DDRB  *AT91C_PIOB_OWER
#define	   	DDRC  *AT91C_PIOC_OWER
#define	   	DDRD  *AT91C_PIOD_OWER

#define	    PULA  *AT91C_PIOA_PPUER //Pull-up Enable Resistor for port x(a,b or c  , d ) 
#define	   	PULB  *AT91C_PIOB_PPUER
#define	   	PULC  *AT91C_PIOC_PPUER
#define	   	PULLD *AT91C_PIOD_PPUER

#define	    MDERA *AT91C_PIOA_PCER //Multi-driver  Enable Resistor for port x(a,b or c  , d )(configured Port as open drain) 
#define	   	MDERB *AT91C_PIOB_PCER
#define	   	MDERC *AT91C_PIOC_PCER
#define	   	MDERD *AT91C_PIOD_PCER

#define	    MDDRA *AT91C_PIOA_MDDR//Multi-driver  disable Resistor for port x(a,b or c  , d )(configured Port as open drain) 
#define	   	MDDRB *AT91C_PIOB_MDDR
#define	   	MDDRC *AT91C_PIOC_MDDR
#define	   	MDDRD *AT91C_PIOD_MDDR

#define	    IFERA *AT91C_PIOA_IFER//input filter  Enable Resistor for port x(a,b or c  , d )(configured Port as open drain) 
#define	   	IFERB *AT91C_PIOB_IFER
#define	   	IFERC *AT91C_PIOC_IFER
#define	   	IFERD *AT91C_PIOD_IFER

#define	    IFDRA *AT91C_PIOA_IFDR//input filter  disable Resistor for port x(a,b or c  , d )(configured Port as open drain) 
#define	   	IFDRB *AT91C_PIOB_IFDR
#define	   	IFDRC *AT91C_PIOC_IFDR
#define	   	IFDRD *AT91C_PIOD_IFDR

#define	   	PAER  *AT91C_PIOC_ASR	  //PERIPH A Enable Resistor
#define	   	PBER  *AT91C_PIOC_BSR	   //PERIPH B Enable Resistor

#define	    INERA *AT91C_PIOA_IER//Interrupt  Enable Resistor for port x(a,b or c  , d )(configured Port as open drain) 
#define	   	INERB *AT91C_PIOB_IER
#define	   	INERC *AT91C_PIOC_IER
#define	   	INERD *AT91C_PIOD_IER

#define	    INDRA *AT91C_PIOA_IDR//Interrupt  Disable Resistor for port x(a,b or c  , d )(configured Port as open drain) 
#define	   	INDRB *AT91C_PIOB_IDR
#define	   	INDRC *AT91C_PIOC_IDR
#define	   	INDRD *AT91C_PIOD_IDR

#define	   	SETA  *AT91C_PIOA_SODR	//SET 	 port x(a,b or c  , d )  
#define	   	SETB  *AT91C_PIOB_SODR
#define	   	SETC  *AT91C_PIOC_SODR
#define	   	SETD  *AT91C_PIOD_SODR

#define	   	RSTA  *AT91C_PIOA_CODR	//RESET 	 port x(a,b or c  , d )  
#define	   	RSTB  *AT91C_PIOB_CODR
#define	   	RSTC  *AT91C_PIOC_CODR
#define	   	RSTD  *AT91C_PIOD_CODR

#define	   	PORTA *AT91C_PIOA_ODSR 	//SET -RESET 	 port x(a,b or c  , d )  
#define	   	PORTB *AT91C_PIOB_ODSR 
#define	   	PORTC *AT91C_PIOC_ODSR 
#define	   	PORTD *AT91C_PIOD_ODSR


unsigned int PINA(char pina) {
unsigned int stacka=0;
*AT91C_PMC_PCER= (1 << AT91C_ID_PIOA);
stacka=*AT91C_PIOA_PDSR;
stacka=(stacka>>pina);
stacka=(stacka&1);
return (stacka) ;
}

unsigned int PINB(char pinb){
unsigned int stackb=0;
*AT91C_PMC_PCER= (1 << AT91C_ID_PIOB);
stackb=*AT91C_PIOB_PDSR;
stackb=(stackb>>pinb);
stackb=(stackb&1);
return(stackb);
}



#define PA0        (1 <<  0)
#define PA1        (1 <<  1)
#define PA2        (1 <<  2)
#define PA3        (1 <<  3)
#define PA4        (1 <<  4)
#define PA5        (1 <<  5)
#define PA6        (1 <<  6)
#define PA7        (1 <<  7)
#define PA8        (1 <<  8)
#define PA9        (1 <<  9)
#define PA10        (1 <<  10)
#define PA11        (1 <<  11)
#define PA12        (1 <<  12)
#define PA13        (1 <<  13)
#define PA14        (1 <<  14)
#define PA15        (1 <<  15)
#define PA16        (1 <<  16)
#define PA17        (1 <<  17)
#define PA18        (1 <<  18)
#define PA19        (1 <<  19)
#define PA20        (1 <<  20)
#define PA21        (1 <<  21)
#define PA22        (1 <<  22)
#define PA23        (1 <<  23)
#define PA24        (1 <<  24)
#define PA25        (1 <<  25)
#define PA26        (1 <<  26)
#define PA27        (1 <<  27)
#define PA28        (1 <<  28)
#define PA29        (1 <<  29)
#define PA30        (1 <<  30)
#define PA31        (1 <<  31)

#define PB0        (1 <<  0)
#define PB1        (1 <<  1)
#define PB2        (1 <<  2)
#define PB3        (1 <<  3)
#define PB4        (1 <<  4)
#define PB5        (1 <<  5)
#define PB6        (1 <<  6)
#define PB7        (1 <<  7)
#define PB8        (1 <<  8)
#define PB9        (1 <<  9)
#define PB10        (1 <<  10)
#define PB11        (1 <<  11)
#define PB12        (1 <<  12)
#define PB13        (1 <<  13)
#define PB14        (1 <<  14)
#define PB15        (1 <<  15)
#define PB16        (1 <<  16)
#define PB17        (1 <<  17)
#define PB18        (1 <<  18)
#define PB19        (1 <<  19)
#define PB20        (1 <<  20)
#define PB21        (1 <<  21)
#define PB22        (1 <<  22)
#define PB23        (1 <<  23)
#define PB24        (1 <<  24)
#define PB25        (1 <<  25)
#define PB26        (1 <<  26)
#define PB27        (1 <<  27)
#define PB28        (1 <<  28)
#define PB29        (1 <<  29)
#define PB30        (1 <<  30)
#define PB31        (1 <<  31)
#endif

